# encoding: utf-8

# Algumas soluções dos exercícios sobre a introdução.
#
# Página: http://malbarbo.pro.br/ensino/2013/7256/
# Autor : Marco A L Barbosa <marco@malbarbo.pro.br>

from aed import Struct, executa_testes
from exemplos_introducao import Ponto, distancia

# Exercicio 1
def soma_quadrados_maiores(a, b, c):
    '''
    Número, Número, Número -> Número
    Devolve a soma dos quadrados dos dois maiores valores entre a, b e c.
    Exemplos
    >>> soma_quadrados_maiores(3, 4, 5)
    41
    >>> soma_quadrados_maiores(6, 4, 5)
    61
    >>> soma_quadrados_maiores(2, 8, 1)
    68
    '''
    if a > b:
        return soma_quadrados(a, maximo(b, c))
    else:
        return soma_quadrados(b, maximo(a, c))

def soma_quadrados(a, b):
    return a ** 2 + b ** 2

# A função pré definina max pode ser usada ao invés de maximo
def maximo(a, b):
    if a > b:
        return a
    else:
        return b


# Exercício 3
# Implementação simples
def quadrado_perfeito1(n):
    '''
    Natural -> Boolean
    Devolve True se n é quadrado perfeito, False caso contrário.
    Exemplos:
    >>> quadrado_perfeito1(5)
    False
    >>> quadrado_perfeito1(9)
    True
    >>> quadrado_perfeito1(15)
    False
    >>> quadrado_perfeito1(16)
    True
    '''
    i = 1
    while i ** 2 < n:
        i = i + 1
    return i ** 2 == n

# Implementação eficiente
def quadrado_perfeito2(n):
    '''
    Natural -> Boolean
    Devolve True se n é quadrado perfeito, False caso contrário.
    Exemplos:
    >>> quadrado_perfeito2(5)
    False
    >>> quadrado_perfeito2(9)
    True
    >>> quadrado_perfeito2(15)
    False
    >>> quadrado_perfeito2(16)
    True
    '''
    return int(n ** 0.5) ** 2 == n


# Exercício 9
def palindromo(xs):
    '''
    Lista -> Boolean
    Devolve True se xs é palindrómo, False caso contrário
    Exemplos:
    >>> palindromo([])
    True
    >>> palindromo([4])
    True
    >>> palindromo([1, 2])
    False
    >>> palindromo([4, 2, 2, 1, 2, 2, 4])
    True
    '''
    for i in range(0, len(xs)):
        if xs[i] != xs[-i-1]:
            return False
    return True


# Exerício 14

class Circulo(Struct):
    '''
    Representa um círculo no plano cartesiano.
        centro : Ponto - é o centro do círculo
        raio : Número - é o raio do círculo
    '''
    def __init__(self, centro, raio):
        self.init(centro, raio)

# Exercício 16

def dentro_circulo(c, p):
    '''
    Circulo, Ponto -> Boolean
    Devolve True se o ponto p está dentro do círculo c, False caso contrário.
    Exemplos:
    >>> dentro_circulo(Circulo(Ponto(3, 4), 10), Ponto(20, 10))
    False
    >>> dentro_circulo(Circulo(Ponto(3, 4), 10), Ponto(6, 7))
    True
    >>> dentro_circulo(Circulo(Ponto(3, 4), 10), Ponto(13, 4))
    True
    '''
    return distancia(p, c.centro) <= c.raio

if __name__ == '__main__':
    executa_testes()
